<!-- Copyright 2017 The Chromium Authors. All rights reserved.
     Use of this source code is governed by a BSD-style license that can be
     found in the LICENSE file. -->

<link rel="import" href="chrome://resources/cr_elements/icons.html">
<link rel="import" href="chrome://resources/html/i18n_behavior.html">
<link rel="import" href="chrome://resources/polymer/v1_0/paper-progress/paper-progress.html">
<link rel="import" href="chrome://resources/polymer/v1_0/paper-styles/color.html">
<link rel="import" href="chrome://oobe/custom_elements.html">

<link rel="import" href="/components/oobe_dialog.html">
<link rel="import" href="/components/oobe_i18n_behavior.html">
<link rel="import" href="/components/throbber_notice.html">

<dom-module id="encryption-migration-element">
  <template>
    <style include="oobe-dialog-host"></style>
    <link rel="stylesheet" href="encryption_migration.css">
    <oobe-dialog tabindex="0" has-buttons for-step="initial">
    </oobe-dialog>
    <oobe-dialog tabindex="0" id="ready-dialog" has-buttons
        title-key="migrationReadyTitle" for-step="ready"
        subtitle-key="migrationReadyDescription">
      <iron-icon slot="oobe-icon" class="warning-icon"></iron-icon>
      <div slot="footer" class="layout vertical center center-justified"
          hidden="[[!isEnoughBattery]]">
        <img srcset="images/security_update_1x.png 1x,
                     images/security_update_2x.png 2x"
             class="oobe-illustration">
      </div>
      <div slot="footer" class="layout vertical" aria-live="polite"
          hidden="[[isEnoughBattery]]">
        <div class="warning">
          [[computeBatteryWarningLabel_(locale, batteryPercent)]]
        </div>
        <template is="dom-if" if="[[isCharging]]">
          <div>[[i18nDynamic(locale,'migrationChargingLabel')]]</div>
        </template>
        <template is="dom-if" if="[[!isCharging]]">
          <div>[[i18nDynamic(locale,'migrationAskChargeMessage')]]</div>
        </template>
        <div>
          [[computeNecessaryBatteryLevelLabel_(locale,
                                               necessaryBatteryPercent)]]
        </div>
      </div>
      <div slot="bottom-buttons" class="flex layout horizontal"
          hidden="[[isResuming]]">
        <div class="flex"></div>
        <oobe-text-button border id="skip-button" on-click="onSkip_"
            hidden="[[isSkipHidden_()]]" text-key="migrationButtonSkip">
        </oobe-text-button>
        <oobe-text-button inverse id="upgrade-button" on-click="onUpgrade_"
            disabled="[[isUpdateDisabled_(isEnoughBattery, isSkipped)]]"
            text-key="migrationButtonUpdate"></oobe-text-button>
      </div>
    </oobe-dialog>
    <oobe-dialog id="migrating-dialog" tabindex="0" for-step="migrating"
        title-key="migrationMigratingTitle"
        subtitle-key="migrationMigratingDescription">
      <iron-icon slot="oobe-icon" class="chrome-logo"></iron-icon>
      <div slot="footer" class="flex layout vertical">
        <paper-progress id="migration-progress"
            value="[[progress]]" max="1" step="0.001"
            indeterminate="[[isProgressIndeterminate_(progress)]]">
        </paper-progress>
        <template is="dom-if" if="[[!isProgressIndeterminate_(progress)]]">
          <div aria-live="polite">
            [[computeProgressLabel_(locale, progress)]]
          </div>
        </template>
      </div>
    </oobe-dialog>
    <oobe-dialog id="error-dialog" tabindex="0" has-buttons
        title-key="migrationFailedTitle" for-step="migration-failed"
        subtitle-key="migrationFailedSubtitle">
      <iron-icon icon="cr:warning" slot="oobe-icon" class="warning">
      </iron-icon>
      <div slot="footer">
        <div>[[i18nDynamic(locale,'migrationFailedMessage')]]</div>
      </div>
      <div slot="bottom-buttons" class="flex layout horizontal">
        <div class="flex"></div>
<if expr="_google_chrome">
        <oobe-text-button border on-click="onReportAnIssue_"
            text-key="migrationButtonReportAnIssue"></oobe-text-button>
</if>
        <oobe-text-button inverse id="restart-button"
            on-click="onRestartOnFailure_" text-key="migrationButtonRestart">
        </oobe-text-button>
      </div>
    </oobe-dialog>
    <oobe-dialog id="insufficient-space-dialog" tabindex="0" has-buttons
        title-key="migrationReadyTitle" for-step="not-enough-space"
        subtitle-key="migrationReadyDescription">
      <iron-icon slot="oobe-icon" class="chrome-logo"></iron-icon>
      <div slot="footer" class="layout vertical" aria-live="polite">
        <div class="warning">
          [[i18nDynamic(locale,'migrationNospaceWarningLabel')]]
        </div>
        <div>[[i18nDynamic(locale,'migrationAskFreeSpaceMessage')]]</div>
        <div>
          [[computeAvailableSpaceLabel_(locale, availableSpaceInString)]]
        </div>
        <div>
          [[computeNecessarySpaceLabel_(locale, necessarySpaceInString)]]
        </div>
      </div>
      <div slot="bottom-buttons" class="flex layout horizontal">
        <div class="flex"></div>
        <oobe-text-button inverse id="insufficient-space-skip-button"
            hidden="[[isResuming]]"
            on-click="onSkip_" text-key="migrationButtonContinue">
        </oobe-text-button>
        <oobe-text-button inverse id="insufficient-space-restart-button"
            hidden="[[!isResuming]]"
            on-click="onRestartOnLowStorage_"
            text-key="migrationButtonRestart">
        </oobe-text-button>
      </div>
    </oobe-dialog>
  </template>
</dom-module>
